%define anolis_release 1
%global somajor 9
%global sominor 0
%global sotiny  0
%global soversion %{somajor}.%{sominor}.%{sotiny}

%ifarch	x86_64
%global	vpxtarget x86_64-linux-gcc
%else
%ifarch aarch64
%global vpxtarget arm64-linux-gcc
%else
%global vpxtarget generic-gnu
%endif
%endif

Name:			libvpx
Summary:		VP8/VP9 Video Codec SDK
Version:		1.14.1
Release:		%{anolis_release}%{?dist}
License:		BSD
URL:			http://www.webmproject.org/code/
Source0:		https://github.com/webmproject/libvpx/archive/v%{version}.tar.gz
Source1:		vpx_config.h
Source2:		libvpx.ver
#Patch0:			CVE-2023-5217.patch
#Patch1:			CVE-2023-44488.patch

BuildRequires: make gcc gcc-c++ yasm doxygen php-cli perl(Getopt::Long)

%description
libvpx provides the VP8/VP9 SDK, which allows you to integrate your applications 
with the VP8 and VP9 video codecs, high quality, royalty free, open source codecs 
deployed on millions of computers and devices worldwide. 

%package devel
Summary:		Development files for libvpx
Requires:		%{name} = %{EVR}

%description devel
Development libraries and headers for developing software against 
libvpx.

%package utils
Summary:		VP8 utilities and tools
Requires:		%{name} = %{EVR}

%description utils
A selection of utilities and tools for VP8, including a sample encoder
and decoder.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n libvpx-%{version}

%build
%set_build_flags

./configure --target=%{vpxtarget} \
--enable-pic --disable-install-srcs \
--enable-vp9-decoder --enable-vp9-encoder \
--enable-experimental \
--enable-vp9-highbitdepth \
--enable-debug \
--enable-shared \
--enable-install-srcs \
--prefix=%{_prefix} --libdir=%{_libdir} --size-limit=16384x16384

%make_build verbose=true


%install
make DIST_DIR=%{buildroot}%{_prefix} dist

if [ -d %{buildroot}%{_prefix}/docs ]; then
   mv %{buildroot}%{_prefix}/docs doc/
fi

pushd %{buildroot}
rm -rf .%{_prefix}/build/ .%{_prefix}/md5sums.txt .%{_libdir}*/*.a .%{_prefix}/CHANGELOG .%{_prefix}/README
mv .%{_bindir}/examples/* .%{_bindir}
rm -rf .%{_bindir}/examples

mv .%{_bindir}/postproc .%{_bindir}/vp8_postproc
mv .%{_bindir}/simple_decoder .%{_bindir}/vp8_simple_decoder
mv .%{_bindir}/simple_encoder .%{_bindir}/vp8_simple_encoder
mv .%{_bindir}/twopass_encoder .%{_bindir}/vp8_twopass_encoder
chmod 755 .%{_bindir}/*
popd

cp -a vpx_config.h %{buildroot}%{_includedir}/vpx/vpx_config-%{_arch}.h
cp %{SOURCE1} %{buildroot}%{_includedir}/vpx/vpx_config.h
touch -r AUTHORS %{buildroot}%{_includedir}/vpx/vpx_config.h

mv %{buildroot}%{_prefix}/src/vpx_dsp %{buildroot}%{_includedir}/
mv %{buildroot}%{_prefix}/src/vpx_mem %{buildroot}%{_includedir}/
mv %{buildroot}%{_prefix}/src/vpx_ports %{buildroot}%{_includedir}/
mv %{buildroot}%{_prefix}/src/vpx_scale %{buildroot}%{_includedir}/

rm -rf %{buildroot}%{_prefix}/src

%files
%license LICENSE
%{_libdir}/libvpx.so.%{somajor}*

%files devel
%doc docs/html/
%{_includedir}/vpx/
%{_includedir}/vpx_dsp/
%{_includedir}/vpx_mem/
%{_includedir}/vpx_ports/
%{_includedir}/vpx_scale/
%{_libdir}/pkgconfig/vpx.pc
%{_libdir}/libvpx.so

%files utils
%{_bindir}/*

%files doc
%doc AUTHORS CHANGELOG README

%changelog
* Thu Jul 04 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.14.1-1
- update to 1.14.1

* Fri Sep 29 2023 Funda Wang <fundawang@yeah.net> - 1.12.0-3
- Fix CVE-2023-5217 & CVE-2023-44488

* Wed Apr 12 2023 Kaihao Bai <carlo.bai@linux.alibaba.com> - 1.12.0-2
- optimize spec

* Fri Jan 20 2023 Funda Wang <fundawang@yeah.net> - 1.12.0-1
- New version 1.12.0

* Thu Apr 07 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.11.0-1
- Init from upstream version 1.11.0

